import isNode from"../../helpers/isNode.js";import stringOrIntToMs from"../../helpers/stringOrIntToMs.js";import LRU from"./algorithms/LRU.js";import RedisLRU from"./algorithms/Redis.js";import{inMemory}from"./handlers/inMemory.js";import{inRedis}from"./handlers/inRedis.js";var ALGORITHMS={LRU:"lru"};var DEFAULT_TTL=500;var caches={};var _cache=function(param){var ref=param===void 0?{}:param,algorithm=ref.algorithm,fnName=ref.fnName,instance=ref.instance,original=ref.original,size=ref.size,target=ref.target,ttl=ref.ttl,redis=ref.redis,cacheKeyString=ref.cacheKeyString;var shouldUseRedisCache=redis&&isNode;var shouldUseMemoryCache=!isNode||!redis;var cacheKey=cacheKeyString||target.constructor.name+"::"+fnName;var cache=caches[cacheKey];if(!cache&&shouldUseRedisCache){console.warn("[sui-decorators/cache] You are using redis cache for cacheKey: "+cacheKey+", your method MUST return a promise");cache=new RedisLRU({size:size,redisConnection:redis,namespace:cacheKey,ttl:ttl});caches[cacheKey]=cache}if(!cache&&shouldUseMemoryCache){redis&&console.warn("[sui-decorators/cache] Your redis config will be ignored in client side. Using the default inMemory LRU strategy.");cache=new LRU({size:size});caches[cacheKey]=cache}return shouldUseRedisCache?inRedis(target,cache,original,fnName,instance,ttl,cacheKey):inMemory(target,cache,original,fnName,instance,ttl)};var _invalidateCache=function(param){var original=param.original,instance=param.instance,cacheKeyString=param.cacheKeyString;var cache=caches[cacheKeyString];if(cache){cache.clear()}return function(){for(var _len=arguments.length,args=new Array(_len),_key=0;_key<_len;_key++){args[_key]=arguments[_key]}return original.apply(instance,args)}};export var cache=function(param){var ref=param===void 0?{}:param,_ttl=ref.ttl,ttl=_ttl===void 0?DEFAULT_TTL:_ttl,_server=ref.server,server=_server===void 0?false:_server,_algorithm=ref.algorithm,algorithm=_algorithm===void 0?ALGORITHMS.LRU:_algorithm,size=ref.size,redis=ref.redis,cacheKeyString=ref.cacheKeyString;var timeToLife=stringOrIntToMs({ttl:ttl})||DEFAULT_TTL;return function(target,fnName,descriptor){if(typeof window!=="undefined"&&window.__SUI_CACHE_DISABLED__||typeof global!=="undefined"&&global.__SUI_CACHE_DISABLED__){return descriptor}if(isNode&&!server){return descriptor}if(!isNode&&redis){console.warn("[sui-decorators/cache] Your redis config will be ignored in client site. Using the default LRU strategy.")}var configurable=descriptor.configurable,enumerable=descriptor.enumerable,writable=descriptor.writable;var originalGet=descriptor.get;var originalValue=descriptor.value;var isGetter=!!originalGet;return Object.assign({},{configurable:configurable,enumerable:enumerable,get:function(){var fn=isGetter?originalGet.call(this):originalValue;if(this===target){return fn}var _fnCached=_cache({algorithm:algorithm,fnName:fnName,instance:this,original:fn,size:size,target:target,ttl:timeToLife,redis:redis,cacheKeyString:cacheKeyString});Object.defineProperty(this,fnName,{configurable:configurable,writable:writable,enumerable:enumerable,value:_fnCached});return _fnCached},set:function(newValue){Object.defineProperty(this,fnName,{configurable:true,writable:true,enumerable:true,value:newValue});return newValue}})}};export var invalidateCache=function(param){var cacheKeyString=(param===void 0?{}:param).cacheKeyString;return function(target,fnName,descriptor){var configurable=descriptor.configurable,enumerable=descriptor.enumerable,writable=descriptor.writable;var originalGet=descriptor.get;var originalValue=descriptor.value;var isGetter=!!originalGet;return Object.assign({},{configurable:configurable,enumerable:enumerable,get:function(){var fn=isGetter?originalGet.call(this):originalValue;if(this===target){return fn}var _fnCached=_invalidateCache({instance:this,original:fn,cacheKeyString:cacheKeyString});Object.defineProperty(this,fnName,{configurable:configurable,writable:writable,enumerable:enumerable,value:_fnCached});return _fnCached},set:function(newValue){Object.defineProperty(this,fnName,{configurable:true,writable:true,enumerable:true,value:newValue});return newValue}})}};export default cache;